## libpappsomspp 0.11.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# CMake script for PAPPSOms++ library
# Authors: Olivier Langella & Filippo Rusconi
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

############################################################
############################################################
# Basic information about project

project(libpappsomspp)

set(PAPPSOMSPP_VERSION_MAJOR "0")
set(PAPPSOMSPP_VERSION_MINOR "11")
set(PAPPSOMSPP_VERSION_PATCH "3")
set(PAPPSOMSPP_VERSION "${PAPPSOMSPP_VERSION_MAJOR}.${PAPPSOMSPP_VERSION_MINOR}.${PAPPSOMSPP_VERSION_PATCH}")
set(MASSCHROQ_VERSION "3.0.2")

# Command to enable debug and tests
# cmake -DCMAKE_BUILD_TYPE=Debug  -DMAKE_TESTS=1 -DUSEPAPPSOTREE=0 ..

message(STATUS "${BoldYellow}CMAKE_LIBRARY_ARCHITECTURE: ${CMAKE_LIBRARY_ARCHITECTURE}${ColourReset}")

# This line MUST be located prior to include'ing GNUInstallDirs !!!
#############################################################
#############################################################
# Installation prefix
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr/local"
    CACHE PATH "Install path" FORCE)
else()
    set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"
    CACHE PATH "Install path" FORCE)
endif()
include(GNUInstallDirs)

message(STATUS "Set CMAKE_INSTALL_PREFIX to ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Install directory prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_FULL_LIBDIR: ${CMAKE_INSTALL_FULL_LIBDIR}")
message(STATUS "CMAKE_INSTALL_FULL_INCLUDEDIR: ${CMAKE_INSTALL_FULL_INCLUDEDIR}")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)

configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

# We need a variable that is not modified by CMake because we'll need to access
# that specific directory later
set(LOCAL_CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
message("CMakeLists.txt - LOCAL_CMAKE_MODULE_PATH:" ${LOCAL_CMAKE_MODULE_PATH})

# Now add our local path to the general path list.
set(CMAKE_MODULE_PATH ${LOCAL_CMAKE_MODULE_PATH} ${CMAKE_MODULE_PATH})

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
    add_definitions(-Werror)
endif()

message(STATUS "${BoldYellow}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")

option(MXE "Use the cross-compiling environment MXE" OFF)
option(WIN10MINGW64 "Use the Msys64/ucrt64 compiling environment" OFF)

#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-$ENV{USER}.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)
    # Run the following cmake command line:
    # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
    #include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)

elseif(WIN32 OR _WIN32)

    if(WIN10MINGW64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
    endif()

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TESTS 1)

option(MAKE_TESTS Off)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode with MAKE_TESTS: ${MAKE_TESTS}.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

# PWIZLITE
if(NOT PwizLite_FOUND)
    message(STATUS "PwizLite not yet found. Searching for it.")
    find_package(PwizLite REQUIRED)
endif()
message(STATUS "PwizLite_INCLUDE_DIRS: ${PwizLite_INCLUDE_DIRS}")
message(STATUS "PwizLite_LIBRARIES: ${PwizLite_LIBRARIES}")

# BOOST
if(NOT Boost_FOUND)
    message(STATUS "Boost not yet found. Searching for it.")
    find_package(
        Boost
        COMPONENTS iostreams thread filesystem chrono
        REQUIRED
    )
endif()
message(STATUS "Boost_LIBRARIES found ${Boost_LIB_VERSION}")
message(STATUS "Boost_INCLUDES: ${Boost_INCLUDE_DIRS}")
message(STATUS "Boost_LIB_DIRS: ${Boost_LIBRARY_DIRS}")

# QCustomPlotQt6
if(QCustomPlotQt6_FOUND)

else(QCustomPlotQt6_FOUND)
    set(QCustomPlotQt6_DIR ${CMAKE_MODULE_PATH})
    find_package(QCustomPlotQt6 REQUIRED)
endif(QCustomPlotQt6_FOUND)

message(STATUS "CMakeLists.txt - CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")

if(Zstd_FOUND)

else(Zstd_FOUND)
    set(Zstd_DIR ${CMAKE_MODULE_PATH})
    find_package(Zstd REQUIRED)
endif(Zstd_FOUND)

if(SQLite3_FOUND)

else(SQLite3_FOUND)
    set(SQLite3_DIR ${CMAKE_MODULE_PATH})
    find_package(SQLite3 REQUIRED)
endif(SQLite3_FOUND)

if(NOT USEPAPPSOTREE)
    set(USEPAPPSOTREE 0)
endif(NOT USEPAPPSOTREE)

# Subdirectories
#generate Doxyfile even if doxygen is not configured
configure_file(${CMAKE_SOURCE_DIR}/doc/Doxyfile.in ${CMAKE_BINARY_DIR}/doc/Doxyfile @ONLY)
message(STATUS "Adding subdirectory doc for ${PROJECT_NAME}")
add_subdirectory(doc)

message(STATUS "Adding subdirectory src for ${PROJECT_NAME}")
add_subdirectory(src)

# Doxygen
if(UNIX AND NOT APPLE)
    find_package(Doxygen)

    if(DOXYGEN_FOUND)

        add_custom_target(
            apidoc
            cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
            COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        )

        add_custom_target(
            apidoc-stable
            cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        )

    endif(DOXYGEN_FOUND)

endif(UNIX AND NOT APPLE)

#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../${CMAKE_PROJECT_NAME}_${PAPPSOMSPP_VERSION}.orig.tar.gz
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}_${PAPPSOMSPP_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

# Packager
set(CPACK_PACKAGE_NAME "libpappsomspp")
set(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
set(CPACK_PACKAGE_VERSION "${PAPPSOMSPP_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${PAPPSOMSPP_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PAPPSOMSPP_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PAPPSOMSPP_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The PAPPSO C++ library for mass spectrometry")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
set(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
    \\\\.git/
    "CMakeFiles"
    "Makefile"
    "_CPack_Packages"
    "CMakeCache.txt"
    ".*\\\\.gz"
    ".*\\\\.deb"
    ".*\\\\.rpm"
    ".*\\\\.dmg"
    ".*\\\\..*\\\\.swp"
    "src/\\\\..*"
    "src/libbpp*"
    "debian/tmp"
    "debian/libbpp.*/"
    "debian/libbpp.*\\\\.so.*"
    "debian/libbpp.*\\\\.a"
    "debian/libbpp.*\\\\.substvars"
    "debian/libbpp.*\\\\.debhelper"
    "debian/debhelper\\\\.log"
    "html"
    "Core.tag"
    "Testing"
    "build/"
    "wbuild/"
    "buildwin64/"
    "build-stamp"
    "install_manifest.txt"
    "DartConfiguration.tcl"
    ${CPACK_SOURCE_IGNORE_FILES}
    ".cache"
    "Session.vim"
    "compile_commands.json"
    ".kdev4"
    "*.kdev4"
)

#dch -Dstretch "message"
#cmake ..
#make deb
# scp libpappsomspp* proteus.ideev.universite-paris-saclay.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
# apt-get remove libpappsomspp*
#
#  debuild -S -sa
# dput -f olivier-langella *changes

#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols

#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols

if(MACOS)
    set(CPACK_GENERATOR "Bundle")
endif()

set(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
)
set(CPACK_DEBSOURCE_PACKAGE_FILE_NAME

=== doc/CMakeLists.txt ===
find_package(Doxygen)

if(DOXYGEN_FOUND)

    set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
    set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${doxyfile_in} ${doxyfile} @ONLY)

    add_custom_target(doc
        COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
        COMMENT "Generating API documentation with Doxygen"
        VERBATIM)

    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/doc/libpappsomspp OPTIONAL )

endif(DOXYGEN_FOUND)

add_subdirectory(js_qml)

=== src/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

# We need this subdirectory because we want to  be able to access all the headers
# using #include <pappsomspp/...> when developing software that uses this
# library and that we want to use it in its development location, not  as
# an installed library.
message("Addding subdirectory pappsomspp for ${PROJECT_NAME}")

add_subdirectory(pappsomspp)

message("\n${BoldGreen}Done configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

=== src/pappsomspp/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

# See below how this file is installed in the destination /prefix/include/pappsomspp directory.
configure_file(${CMAKE_UTILS_PATH}/src-pappsomspp-config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/config.h)

# Now we can configure the build of both libraries
add_subdirectory(core)
add_subdirectory(gui)


# Install headers (valid for both the static and the shared lib versions)
install(
    DIRECTORY core
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp/
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
)

# Install headers (valid for both the static and the shared lib versions)
install(
    DIRECTORY gui
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp/
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
)

# Install headers (valid for both the static and the shared lib versions)
message("Installing config.h from ${CMAKE_CURRENT_BINARY_DIR} to ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp")
install(
    FILES config.h export-import-config.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp
)

message("\n${BoldGreen}Done configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

=== tests/benchmarks/CMakeLists.txt ===

  # These source files are compiled into a single Catch2-based test binary.
  # tests dedicated to check speed performances (benchmarks)
  set(catch2_only_cpp_benchmark_SRCS
    test_msrunreaderng.cpp
    test_proteinycodefasta.cpp
    test_timsxicextractor.cpp
    test_timsxicextractor_based_masspec.cpp
  )

  add_executable(catch2-only-benchmarks
    ../common.cpp
    ../proteincode/proteincode_lib.cpp
    ${catch2_only_cpp_benchmark_SRCS}
  )

  target_include_directories(catch2-only-benchmarks PUBLIC
    ${CMAKE_BINARY_DIR} # so that #include "tests/config.h" works
    #${CMAKE_CURRENT_BINARY_DIR} # for heretic #include "ui_uiobotermform.h"
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2 Catch2::Catch2WithMain
  )

  set_property(TARGET catch2-only-benchmarks PROPERTY CXX_STANDARD 17) # we want C++17


  target_link_libraries(catch2-only-benchmarks
    Core
    Catch2::Catch2
    Catch2::Catch2WithMain
    liblzf::liblzf
    Boost::chrono
    QuaZip::QuaZip
    OdsStream::Core
    )

=== tests/dia/CMakeLists.txt ===

  # These source files are compiled into a single Catch2-based test binary.
  # tests dedicated to check speed performances (benchmarks)
  set(catch2_only_cpp_dia_SRCS
    test_soleil.cpp
  )

  add_executable(catch2-only-dia
    ../common.cpp
    dia_lib.cpp
    ${catch2_only_cpp_dia_SRCS}
  )

  target_include_directories(catch2-only-dia PUBLIC
    ${CMAKE_BINARY_DIR} # so that #include "tests/config.h" works
    #${CMAKE_CURRENT_BINARY_DIR} # for heretic #include "ui_uiobotermform.h"
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2 Catch2::Catch2WithMain
  )

  target_link_libraries(catch2-only-dia
    ${required_target_link_libraries})

=== tests/pappsotree/CMakeLists.txt ===


  # These source files are compiled into a single Catch2-based test binary.
  # tests dedicated to check speed performances (benchmarks)
  set(catch2_only_cpp_pappsotree_SRCS
    test_cborpsm.cpp
    test_cborpsm2json.cpp
    test_cborsage.cpp
    test_cbormzid.cpp
    test_msrun.cpp
    test_msrunalignment.cpp
    test_tims_dda.cpp
    test_tims_dia.cpp
    test_tims_dia_micro.cpp
    test_tims_dia_micro_slice.cpp
    test_tims_dia_nano.cpp
    test_msrunreaderng_tims.cpp
    test_msrunreaderng.cpp
    test_tims_data_xic_chromatogram.cpp
    test_tims_ion_mobility_grid.cpp
  )

  add_executable(catch2-only-pappsotree
    ../common.cpp
    ${catch2_only_cpp_pappsotree_SRCS}
  )

get_target_property(INCLUDE_DIRS catch2-only-pappsotree INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-pappsotree: ${INCLUDE_DIRS}")


  target_link_libraries(catch2-only-pappsotree
    ${required_target_link_libraries})


    target_include_directories(catch2-only-pappsotree PUBLIC
      ${CMAKE_BINARY_DIR}/tests
      
    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
    )

=== tests/peptidoms/CMakeLists.txt ===
# These source files are compiled into a single Catch2-based test binary.
# tests dedicated to check speed performances (benchmarks)
set(catch2_only_cpp_peptidoms_SRCS test_peptidoms.cpp test_fine_4291.cpp test_zea_4291.cpp test_zea_8119.cpp)

if(USE_PAPPSO_TREE)
    set(catch2_only_cpp_peptidoms_pappsotree_SRCS test_double.cpp test_precise_align.cpp test_zea_4512.cpp test_zea_4542.cpp)
endif(USE_PAPPSO_TREE)

add_executable(
    catch2-only-peptidoms
    ${catch2_only_cpp_peptidoms_SRCS} ${catch2_only_cpp_peptidoms_pappsotree_SRCS} ../common.cpp
)

get_target_property(INCLUDE_DIRS catch2-only-peptidoms INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-peptidoms: ${INCLUDE_DIRS}")

target_include_directories(
    catch2-only-peptidoms
    PUBLIC
    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
)

target_link_libraries(
    catch2-only-peptidoms ${required_target_link_libraries}
)

=== src/pappsomspp/core/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/core for ${PROJECT_NAME}${ColourReset}\n")

add_definitions(-DWITHOUT_MZ5)

########################################################
# Files
set(CPP_FILES
    types.cpp
    utils.cpp
    mzrange.cpp
    precision.cpp
    amino_acid/aa.cpp
    amino_acid/aabase.cpp
    amino_acid/aacode.cpp
    amino_acid/aamodification.cpp
    amino_acid/aastringcodec.cpp
    amino_acid/aastringcodemassmatching.cpp
    amino_acid/atomnumberinterface.cpp
    amino_acid/chemicalformula.cpp
    massspectrum/massspectrumid.cpp
    massspectrum/massspectrum.cpp
    massspectrum/qualifiedmassspectrum.cpp
    fasta/fastafileindexer.cpp
    fasta/fastareader.cpp
    fasta/fastaoutputstream.cpp
    grouping/grpexperiment.cpp
    grouping/grppeptide.cpp
    grouping/grpprotein.cpp
    grouping/grpgroup.cpp
    grouping/grpsubgroup.cpp
    grouping/grppeptideset.cpp
    grouping/grpmappeptidetogroup.cpp
    grouping/grpmappeptidetosubgroupset.cpp
    grouping/grpsubgroupset.cpp
    grouping/grpgroupingmonitor.cpp
    masschroq/input/jsoninput.cpp
    masschroq/input/precursorparser.cpp
    masschroq/output/cboroutputstream.cpp
    masschroq/alignmentmethod.cpp
    masschroq/mbrpeptidemeasurements.cpp
    masschroq/msrun.cpp
    masschroq/msrungroup.cpp
    masschroq/msrunpeptidelist.cpp
    masschroq/peptide.cpp
    masschroq/peptidebase.cpp
    masschroq/peptidelabel.cpp
    masschroq/peptidemeasurements.cpp
    masschroq/peptidemeasurementsbase.cpp
    masschroq/peptideobservation.cpp
    masschroq/precursor.cpp
    masschroq/protein.cpp
    masschroq/quantificationmethod.cpp
    masschroq/utils.cpp
    msfile/msfileaccessor.cpp
    msfile/msfilereader.cpp
    msfile/mzformatenumstr.cpp
    msfile/pwizmsfilereader.cpp
    msfile/timsmsfilereader.cpp
    msfile/xymsfilereader.cpp
    msfile/bafasciifilereader.cpp
    msrun/spectrumcollectionhandlerinterface.cpp
    msrun/alignment/msrunretentiontime.cpp
    msrun/alignment/template.cpp
    msrun/output/mzxmloutput.cpp
    msrun/output/mgfoutput.cpp
    msrun/msrundatasettreenode.cpp
    msrun/msrundatasettree.cpp
    msrun/msrunid.cpp
    msrun/msrunreader.cpp
    msrun/msrunreadconfig.cpp
    msrun/private/pwizmsrunreader.cpp
    msrun/private/timsmsrunreader.cpp
    msrun/private/timsmsrunreaderbase.cpp
    msrun/private/timsmsrunreaderdia.cpp
    msrun/private/timsframesmsrunreader.cpp
    msrun/private/timsmsrunreaderms2.cpp
    msrun/private/timsmsrunreaderms2selected.cpp
    msrun/xiccoord/ionmobilitygrid.cpp
    msrun/xiccoord/xiccoord.cpp
    msrun/xiccoord/xiccoordtims.cpp
    msrun/xymsrunreader.cpp
    msrun/bafasciimsrunreader.cpp
    obo/filterobopsimodmap.cpp
    obo/filterobopsimodsink.cpp
    obo/filterobopsimodtermaccession.cpp
    obo/filterobopsimodtermdiffmono.cpp
    obo/filterobopsimodtermlabel.cpp
    obo/filterobopsimodtermname.cpp
    obo/obopsimod.cpp
    obo/obopsimodterm.cpp
    obo/obopsims.cpp
    obo/obounimod.cpp
    peptide/ion.cpp
    peptide/peptideinterface.cpp
    peptide/peptide.cpp
    peptide/peptidefragment.cpp
    peptide/peptidefragmention.cpp
    peptide/peptidefragmentionlistbase.cpp
    peptide/peptidenaturalisotope.cpp
    peptide/peptidenaturalisotopelist.cpp
    peptide/peptidenaturalisotopeaverage.cpp
    peptide/peptideproformaparser.cpp
    peptide/peptiderawfragmentmasses.cpp
    peptide/peptidestrparser.cpp
    processing/cbor/cborstreamreader.cpp
    processing/cbor/cborstreamreaderinterface.cpp
    processing/cbor/cborstreamwriter.cpp
    processing/cbor/jsonstreamwriter.cpp
    processing/cbor/psm/cborscanmapbase.cpp
    processing/cbor/psm/psmcbor2json.cpp
    processing/cbor/psm/psmcborutils.cpp
    processing/cbor/psm/psmfileappend.cpp
    processing/cbor/psm/psmfilereaderbase.cpp
    processing/cbor/psm/psmfilescanprocess.cpp
    processing/cbor/psm/psmfilescanprocessandcopy.cpp
    processing/cbor/psm/psmproteinmap.cpp
    processing/cbor/psm/evalscan/psmfeatures.cpp
    processing/cbor/psm/evalscan/psmfeaturesscan.cpp
    processing/cbor/psm/evalscan/psmionseries.cpp
    processing/cbor/psm/evalscan/psmspecglob.cpp
    processing/cbor/psm/evalscan/psmspecglobscan.cpp
    processing/cbor/psm/evalscan/psmspecpeptidoms.cpp
    processing/cbor/psm/mzidentml/mzidentmlreader.cpp
    processing/cbor/psm/sage/sagefilereader.cpp
    processing/cbor/psm/sage/sagereader.cpp
    processing/cbor/psm/sage/sagetsvhandler.cpp
    processing/combiners/mzintegrationparams.cpp
    processing/combiners/integrationscopebase.cpp
    processing/combiners/integrationscope.cpp
    processing/combiners/integrationscoperect.cpp
    processing/combiners/integrationscoperhomb.cpp
    processing/combiners/selectionpolygon.cpp
    processing/combiners/tracecombiner.cpp
    processing/combiners/traceminuscombiner.cpp
    processing/combiners/tracepluscombiner.cpp
    processing/combiners/massdatacombinerinterface.cpp
    processing/combiners/massspectrumcombiner.cpp
    processing/combiners/massspectrumpluscombiner.cpp
    processing/combiners/massspectrumminuscombiner.cpp
    processing/compartraces/cosinesimilarity.cpp
    processing/detection/tracedetectionzivy.cpp
    processing/detection/tracedetectionmoulon.cpp
    processing/detection/tracepeak.cpp
    processing/detection/tracepeaklist.cpp
    processing/filters/filterchargedeconvolution.cpp
    processing/filters/filtercomplementionenhancer.cpp
    processing/filters/filterexclusionmz.cpp
    processing/filters/filterlocalmaximum.cpp
    processing/filters/filtermorpho.cpp
    processing/filters/filternameinterface.cpp
    processing/filters/filterpass.cpp
    processing/filters/filterpeakdelta.cpp
    processing/filters/filterremovec13.cpp
    processing/filters/filterresample.cpp
    processing/filters/filtersuite.cpp
    processing/filters/filtersuitestring.cpp
    processing/filters/filtertandemremovec13.cpp
    processing/filters/filtertriangle.cpp
    processing/filters/savgolfilter.cpp
    processing/filters/filterflooramplitudepercentage.cpp
    processing/filters/filterceilingamplitudepercentage.cpp
    processing/filters/filterlowintensitysignalremoval.cpp
    processing/filters/filternormalizeintensities.cpp
    processing/project/projectparameters.cpp
    processing/specglob/experimentalspectrum.cpp
    processing/specglob/peptidemodel.cpp
    processing/specglob/peptidespectrum.cpp
    processing/specglob/posttreatment.cpp
    processing/specglob/scorevalues.cpp
    processing/specglob/spectralalignment.cpp
    processing/specpeptidoms/correctiontree.cpp
    processing/specpeptidoms/locationsaver.cpp
    processing/specpeptidoms/peptidemodel.cpp
    processing/specpeptidoms/scenario.cpp
    processing/specpeptidoms/scorevalues.cpp
    processing/specpeptidoms/semiglobalalignment.cpp
    processing/specpeptidoms/spomsprotein.cpp
    processing/specpeptidoms/spomsspectrum.cpp
    processing/specself/selfspectrum.cpp
    processing/specself/selfspectrumdatapoint.cpp
    processing/spectree/bucket.cpp
    processing/spectree/bucketclustering.cpp
    processing/spectree/itemcart.cpp
    processing/spectree/spectree.cpp
    processing/spectree/specxtractinterface.cpp
    processing/tandemwrapper/tandemwrapperrun.cpp
    processing/tandemwrapper/wraptandeminput.cpp
    processing/tandemwrapper/wraptandemresults.cpp
    processing/tandemwrapper/xtandempresetreader.cpp
    processing/uimonitor/uimonitortext.cpp
    processing/uimonitor/uimonitortextpercent.cpp
    processing/xml/mzidentmlwriter.cpp
    processing/xml/xmlstreamreaderinterface.cpp
    protein/enzyme.cpp
    protein/peptidesizefilter.cpp
    protein/peptidebuilder.cpp
    protein/peptidevariablemodificationbuilder.cpp
    protein/peptidevariablemodificationreplacement.cpp
    protein/peptidefixedmodificationbuilder.cpp
    protein/peptidemodificatorbase.cpp
    protein/peptidemodificatortee.cpp
    protein/peptidemethioninremove.cpp
    protein/peptidemodificatorpipeline.cpp
    protein/peptidesemienzyme.cpp
    protein/protein.cpp
    protein/proteinintegercode.cpp
    protein/proteinpresenceabsencematrix.cpp
    psm/deepprot/deepprotenum.cpp
    psm/experimental/ionisotoperatioscore.cpp
    psm/features/psmfeatures.cpp
    psm/morpheus/morpheusscore.cpp
    psm/peakionmatch.cpp
    psm/peakionisotopematch.cpp
    psm/peptidespectrummatch.cpp
    psm/peptideisotopespectrummatch.cpp
    psm/xtandem/xtandemhyperscore.cpp
    psm/xtandem/xtandemhyperscorebis.cpp
    psm/xtandem/xtandemspectrumprocess.cpp
    trace/datapoint.cpp
    trace/linearregression.cpp
    trace/maptrace.cpp
    trace/trace.cpp
    vendors/tims/mobilitytraces/timsframemobilitytraces.cpp
    vendors/tims/mzcalibration/cardano.cpp
    vendors/tims/mzcalibration/mzcalibrationinterface.cpp
    vendors/tims/mzcalibration/mzcalibrationmodel1.cpp
    vendors/tims/mzcalibration/mzcalibrationstore.cpp
    vendors/tims/xicextractor/timsdirectxicextractor.cpp
    vendors/tims/xicextractor/timsxicextractorinterface.cpp
    vendors/tims/timsbindec.cpp
    vendors/tims/timsdata.cpp
    vendors/tims/timsdatafastmap.cpp
    vendors/tims/timsddaprecursors.cpp
    vendors/tims/timsdiaslices.cpp
    vendors/tims/timsframe.cpp
    vendors/tims/timsframerawdatachunck.cpp
    vendors/tims/timsframebase.cpp
    vendors/tims/timsframetype1.cpp
    vendors/tims/timsms2centroidfilter.cpp
    xic/xic.cpp
    xic/qualifiedxic.cpp
    xic/xicpeptideinterface.cpp
    xic/xicpeptidefragmention.cpp
    xic/xicpeptidefragmentionnaturalisotope.cpp
    xicextractor/private/msrunslice.cpp
    xicextractor/private/msrunxicextractor.cpp
    xicextractor/private/msrunxicextractordisk.cpp
    xicextractor/private/msrunxicextractordiskbuffer.cpp
    xicextractor/msrunxicextractorfactory.cpp
    xicextractor/msrunxicextractorinterface.cpp
    #
    # Scripting
    js_qml/jsclassregistrar.cpp
    js_qml/pappsojsqml.cpp
    js_qml/datapointjs.cpp
    js_qml/qpointfjs.cpp
    js_qml/tracejs.cpp
    js_qml/massspectrumjs.cpp
)

# generate rules for building source files from the resources
# and the JS reference text also.
qt6_add_resources(QRC_SRCS libpappsomspp_core_resources.qrc)

message("Generated the following resource files: ${QRC_SRCS}")

file(GLOB_RECURSE Core_HEADERS
    LIST_DIRECTORIES false
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    "*.h"
)
message(STATUS "Core header files: ${Core_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

#############################################################
# Build the static lib
add_library(
    Core_static STATIC
    ${Core_HEADERS} ${CPP_FILES} ${QRC_SRCS}
)

set_target_properties(
    Core_static
    PROPERTIES EXPORT_NAME "Core_static"
               OUTPUT_NAME pappsomspp-core
               CLEAN_DIRECT_OUTPUT 1
               LINK_FLAGS "-Wl,--whole-archive"
)

target_compile_definitions(Core_static PRIVATE -DPMSPP_LIBRARY)

target_link_libraries(
    Core_static
    PUBLIC Boost::iostreams
           Boost::filesystem
           Boost::thread
           Boost::chrono
           PwizLite::PwizLite
           SQLite3::SQLite3
           Qt6::Svg
           Qt6::Sql
           Qt6::Concurrent
           Qt6::Xml
           Qt6::Core5Compat
           Qt6::Core
           Qt6::Qml
           ZLIB::ZLIB
           Zstd::Zstd
           liblzf::liblzf
           OdsStream::Core
)

if(NEEDHDF5)
    target_link_libraries(pappsomspp-static hdf5::hdf5_cpp)
endif(NEEDHDF5)

# FIXME: should check that this still required. It was years ago.
if(WIN32 OR _WIN32)
    #target_link_libraries(Core_static stdc++)
endif()

# The install interface that is ${prefix}/include.

target_include_directories(
    Core_static
    PUBLIC # These include directories are for building of this lib.
           $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>

=== src/pappsomspp/core/js_qml/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Filippo Rusconi
# Created: 28/07/2025

message("\n${BoldGreen}Now configuring src/js_qml for ${PROJECT_NAME}\n${ColourReset}")

# set(CMAKE_INCLUDE_CURRENT_DIR ON)

########################################################
# Files
set(SRC
    datapointjs.cpp
    datapointjs.h
    qpointfjs.cpp
    qpointfjs.h
    ${CMAKE_SOURCE_DIR}/src/pappsomspp/processing/combiners/mzintegrationparams.cpp
    ${CMAKE_SOURCE_DIR}/src/pappsomspp/processing/combiners/mzintegrationparams.h
    tracejs.cpp
    tracejs.h
    massspectrumjs.cpp
    massspectrumjs.h
    jsclassregistrar.cpp
    jsclassregistrar.h
)

# set(js_qml_resources_RCC_SRC js_qml_resources.qrc)
# generate rules for building source files from the resources
# qt6_add_resources(js_qml_resources_RCC ${js_qml_resources_RCC_SRC})

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

set(INCLUDES_DIRS "")
list(APPEND INCLUDES_DIRS "${CMAKE_SOURCE_DIR}/src")
# list(APPEND INCLUDES_DIRS "${CMAKE_CURRENT_BINARY_DIR}")
list(APPEND INCLUDES_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/forwarding_includes)
message(STATUS "src/js_qml INCLUDES_DIRS: ${INCLUDES_DIRS}")

# QML module
qt_add_qml_module(
    # This is the name of target, but the produced library will be
    # libPappsoMSplugin.so on GNU/Linux
    PappsoMS
    URI
    "PappsoMS"
    VERSION
    1.0
    SOURCES
    ${SRC}
    pappsojsqml.cpp
    NO_PLUGIN
    RESOURCE_PREFIX
    ":/qt/qml/"
    OUTPUT_DIRECTORY
    "${CMAKE_CURRENT_BINARY_DIR}/qml/PappsoMS"
    DEPENDENCIES
    Core
)

set_target_properties(PappsoMS PROPERTIES
    OUTPUT_NAME "PappsoMSbindings"
    QML_IMPORT_PATH "${PROJECT_INSTALL_LIB_QML_DIR}"
)

target_link_libraries(
    PappsoMS
    PRIVATE Qt6::Core Qt6::Qml Core
)

target_include_directories(PappsoMS
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/forwarding_includes>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# get_target_property(PappsoMS_INCLUDES PappsoMS INCLUDE_DIRECTORIES)
# message(STATUS "PappsoMS_INCLUDES: ${PappsoMS_INCLUDES}")
# get_target_property(_all_includes PappsoMS INTERFACE_INCLUDE_DIRECTORIES)
# message(STATUS "All interface includes: ${_all_includes}")

set(PROJECT_INSTALL_LIB_QML_DIR ${CMAKE_INSTALL_LIBDIR}/qml)

# Explicitly set the imported library path in the export
set_target_properties(PappsoMS PROPERTIES
    IMPORTED_LOCATION "${PROJECT_INSTALL_LIB_QML_DIR}/PappsoMS/libPappsoMSplugin.so"
    INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/include"
)

# Configure post-install script
configure_file(
    "${CMAKE_UTILS_PATH}//ld_config_post_install_script.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/ld_config_post_install_script.sh"
    @ONLY
)

# Make the plugin available for installation
install(
    TARGETS PappsoMS
    EXPORT PappsoMSTargets
    LIBRARY DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}/PappsoMS
    ARCHIVE DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}/PappsoMS
    RUNTIME DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}/PappsoMS
    BUNDLE DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}/PappsoMS
)

# Generate and install export configuration
install(
    EXPORT PappsoMSTargets
    FILE PappsoMSTargets.cmake
    NAMESPACE PappsoMS::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PappsoMS
)

include(CMakePackageConfigHelpers)
configure_package_config_file(
    ${LOCAL_CMAKE_MODULE_PATH}/PappsoMSConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/PappsoMSConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PappsoMS
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/PappsoMSConfigVersion.cmake
    VERSION 1.0
    COMPATIBILITY SameMajorVersion
)

install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/PappsoMSConfig.cmake" "${CMAKE_CURRENT_BINARY_DIR}/PappsoMSConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PappsoMS
)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/qml/PappsoMS
    DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/pappsojsqml.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp/js_qml
)

install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/src/pappsomspp/js_qml
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp/js_qml
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
)

install(CODE "
    if(UNIX AND NOT APPLE)
        execute_process(
            COMMAND sh \"${CMAKE_CURRENT_BINARY_DIR}/ld_config_post_install_script.sh\"
            RESULT_VARIABLE INSTALL_RESULT
            OUTPUT_VARIABLE INSTALL_OUTPUT
        )
        message(\"${INSTALL_OUTPUT}\")
    endif()
")

message("\n${BoldGreen}Done configuring src/js_qml for ${PROJECT_NAME}\n${ColourReset}")

=== debian/changelog ===
libpappsomspp (0.11.3-1) unstable; urgency=medium

  * New upstream release with a bunch of modifications mainly from Langella
    and only some by Rusconi.

  * Dependency libpwizlite-dev (>= 3.0.11).

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 17 Oct 2025 14:25:08 +0200

libpappsomspp (0.11.2-1~trixie+1) trixie; urgency=medium

  * Lot of work on specpeptidoms and PSM CBOR

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 08 Oct 2025 09:17:33 +0200

libpappsomspp (0.11.1-1~trixie+1) trixie; urgency=medium

  * First backport package for Trixie
  * WIP: specpeptidoms and CBOR file format

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 22 Sep 2025 09:19:20 +0200

=== debian/control ===
Source: libpappsomspp
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-exec,
 cmake,
 d-shlibs,
 libxkbcommon-x11-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 libqt6core5compat6-dev,
 libqt6svg6-dev,
 qt6-documentation-tools,
 libpwizlite-dev (>= 3.0.11),
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.15),
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libboost1.88-dev,
 libboost-chrono1.88-dev,
 libboost-system1.88-dev,
 libboost-container1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-thread1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-random1.88-dev,
 doxygen,
 catch2
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/libpappsomspp
Vcs-Git: https://salsa.debian.org/debichem-team/libpappsomspp.git
Homepage: http://pappso.inrae.fr/bioinfo


Package: libpappsomspp-core0
Architecture: any
Multi-Arch: same
Conflicts: libpappsomspp0
Breaks: libpappsomspp0
Replaces: libpappsomspp0
Depends: libqt6sql6-sqlite,
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ library to handle mass spectrometry data (non-GUI runtime)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the non-GUI library.


Package: libpappsomspp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-dev
Depends: libpappsomspp-core0 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (development files)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the non-GUI library.


Package: libpappsomspp-gui0
Architecture: any
Multi-Arch: same
Conflicts: libpappsomspp-widget0
Breaks: libpappsomspp-widget0
Replaces: libpappsomspp-widget0
Depends: libpappsomspp-core0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library to handle mass spectrometry data (GUI runtime)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the GUI library.


Package: libpappsomspp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget-dev
Depends: libpappsomspp-gui0 (= ${binary:Version}),
         libpappsomspp-core-dev (= ${binary:Version}),
         ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (GUI development files)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the GUI library.


Package: libpappsomspp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ library to handle mass spectrometry data (developer documentation)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package contains the developer documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif


%:
	dh $@ --buildsystem=cmake --builddirectory=build-dir-for-deb

# For automating the d/*.links stuff.
export LIBPAPPSOMSPP_VERSION=$(DEB_VERSION_UPSTREAM)
export LIBPAPPSOMSPP_SOVERSION=0

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  CMAKE_EXTRA_TESTING_ARGS = -DMAKE_TESTS=1 -DBUILD_TESTING=1
endif
# Remove -DMAKE_TESTS=1 \ for the moment
# See comment below.
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_SKIP_RPATH=0 \
		-DUSEPAPPSOTREE=0 \
		$(CMAKE_EXTRA_TESTING_ARGS)

override_dh_auto_clean:
	dh_auto_clean
	rm -f tests/typst/data/*.json

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- doc

override_dh_auto_test:
	# With the monstrous mess of Catch2
	# in version 3.x having totally changed
	# the header files structure with respect
	# to version 2.x, it is not humanely possible
	# to deal with the tests in stable and unstable.
	#
	# Make Catch2-based tests separately
	# so that their output is conserved.
	# See tests/CMakeLists.txt for details.
	cd build-dir-for-deb && make catch2-tests
	dh_auto_test
